sck		equ	p3.3
mosi		equ	p3.4
miso		equ	p3.5
res		equ	p3.7
led		equ	p1.0

                dseg at 21h
                org     21h
FLGS:           ds      2               ;
flgs_sck        bit     (FLGS-20h)*8    ; FLGS.0 - sck status
b2s:		ds	1		; bits to send
sph:		ds	1		; sck phase
outb:		ds	1
inb:		ds	1


sysstack:	ds	32		; systémový stack - ponechat na konci deklarací RAM

                cseg at 0
                ORG      0000H
                JMP      START
                ORG      0003H           ;EXTERNAL INT 0
                RETI     
                ORG      000BH           ;TIMER 0
                JMP      TIM0
                ORG      0013H           ;EXTERNAL INT 1
;                JMP      GETDATA
                RETI     
                ORG      001BH           ;TIMER 1
                reti     

                org   0023h           ; serial
                jmp   SERIO
                           
                ORG     00E0H
START:
		clr	res
		clr	sck
		setb	miso
		clr	mosi
                MOV     SP,#sysstack
                MOV     TH0,#256-50; @12MHz 50us => 20kHz => 5kHz sck
                MOV     TMOD,#00100010B; timer 0 autoreload 
                MOV    	IE,#010000010B         ;EA,ET0 ON
                mov	TH1,#230 ; @12MHz 1200 baud a nějaký drobný
                clr	a
                mov	sph,#3    ; sck phase
                mov	b2s,a	 ; bits to send
                mov	FLGS,a
		setb  	tr1
                mov	SCON,#01010000B
                setb	ES	; serial interruption
                setb	tr0
mainloop:
		jmp	$

TIM0:
		setb	res
		push	acc
		push	psw
		mov	a,b2s
		jz	TIM0r

		clr	led
		mov	c,sph.0
		cpl	c
		anl	c,sph.1
		mov	sck,c
		mov	a,sph
		cjne	a,#3,TIM0phstep
		mov	a,outb
		rlc	a
		mov	mosi,c
		mov	outb,a
		mov	a,inb
		mov	c,miso
		rlc	a
		mov	inb,a
		mov	a,#3
TIM0phstep:
		jz	TIM0phend
		dec	sph
		jmp	TIM0r
TIM0phend:
		mov	sph,#3
		djnz	b2s,TIM0r
		clr	mosi
		mov	SBUF,inb
		setb	led
TIM0r:
		pop	psw
		pop	acc
		reti
SERIO:
		jnb	RI,SERIOy		; nic neprislo (preruseni od vysilani)
		mov	outb,SBUF
		mov	b2s,#8
		clr	RI
		jmp	SERIOr
SERIOy:
		clr	TI
SERIOr:
		reti

		end