#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <errno.h>
#include <termios.h>
#include <unistd.h>

using namespace std;

/////////////////////////////////////////////////
// code from wallyk at stackoverflow.com begin //

int
set_interface_attribs (int fd, int speed, int parity)
{
        struct termios tty;
        memset (&tty, 0, sizeof tty);
        if (tcgetattr (fd, &tty) != 0)
        {
	  printf ("error %d from tcgetattr\n", errno);
                return -1;
        }

        cfsetospeed (&tty, speed);
        cfsetispeed (&tty, speed);

        tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS8;     // 8-bit chars
        // disable IGNBRK for mismatched speed tests; otherwise receive break
        // as \000 chars
        tty.c_iflag &= ~IGNBRK;         // ignore break signal
        tty.c_lflag = 0;                // no signaling chars, no echo,
                                        // no canonical processing
        tty.c_oflag = 0;                // no remapping, no delays
        tty.c_cc[VMIN]  = 0;            // read doesn't block
        tty.c_cc[VTIME] = 1;            // 5? seconds read timeout

        tty.c_iflag &= ~(IXON | IXOFF | IXANY); // shut off xon/xoff ctrl

        tty.c_cflag |= (CLOCAL | CREAD);// ignore modem controls,
                                        // enable reading
        tty.c_cflag &= ~(PARENB | PARODD);      // shut off parity
        tty.c_cflag |= parity;
        tty.c_cflag &= ~CSTOPB;
        tty.c_cflag &= ~CRTSCTS;

        if (tcsetattr (fd, TCSANOW, &tty) != 0)
        {
                printf ("error %d from tcsetattr\n", errno);
                return -1;
        }
        return 0;
}

void
set_blocking (int fd, int should_block)
{
        struct termios tty;
        memset (&tty, 0, sizeof tty);
        if (tcgetattr (fd, &tty) != 0)
        {
                printf ("error %d from tggetattr\n", errno);
                return;
        }

        tty.c_cc[VMIN]  = should_block /*? 1 : 0*/;
        tty.c_cc[VTIME] = 1;            // 5? seconds read timeout

        if (tcsetattr (fd, TCSANOW, &tty) != 0)
                printf ("error %d setting term attributes\n", errno);
}

// code from wallyk at stackoverflow.com end   //
/////////////////////////////////////////////////

struct CMD
{
  bool valid;
  string rd;
  string wr;
  CMD() {rd = ""; wr = ""; valid = false;}
  short int length() {return (rd.length() > wr.length()) ? rd.length() : wr.length();}
};

int mem, pgmin, pgmax, pgstep, pgaddr, fd;
CMD fail, sinit, serase, sread, swrite, sreadp, swritep, srlock, swlock, srsig;
string mcu_type;

unsigned int str2int(string s)
{
  unsigned i;
  string t;
  if (s[s.length() - 1] == 'H')
  {
    s.erase(s.length() - 1);
    t = "%x";
  }
  else
    t = "%d";
  sscanf(s.c_str(), t.c_str(), &i);
  return i;
}

void error(string m)
{
  cerr << "Error: " << m << endl;
  exit(1);
}

string getser(short int len)
{
  string out("");
  char buf[65536];
  int l;
  while (out.length() < len)
  {
    l = read(fd, &buf, 65536);
    for (int i = 0; i < l; i++)
      out += buf[i];
  }
//   set_blocking(fd, len);
//   out.resize(len, 0);
//   if (read(fd, &*out.begin(), len) < len)
//     error("too short reply.");
  return out;
}

string do_cmd(CMD *cmd, short int addr, short int data, string page)
{
  string input("");
  string output("");
  char byte = 0;
  short int addrs = 0;
  short int addrl = 0;
  short int datas = 0;
  short int datal = 0;
  for (short int i = 0; i < cmd->wr.length(); i++)
  {
    switch (cmd->wr[i])
    {
      case ('a'): {addrl = i; break;}
      case ('d'): {datal = i; break;}
    }
  }
  for (short int i = 0; i < cmd->length(); i++)
  {
    if (i < cmd->wr.length())
    {
      switch (cmd->wr[i])
      {
	case ('1'): {byte = byte | (1 << 7 - (i % 8)); break;}
	case ('a'): {byte = byte | (((addr & (1 << (addrl - i))) ? 1 : 0) << 7 - (i % 8)); break;}
	case ('d'): {byte = byte | (((data & (1 << (datal - i))) ? 1 : 0) << 7 - (i % 8)); break;}
	case ('p'): {output += page; goto send;}
      }
      if ((i % 8) == 7)
      {
	output += byte;
	byte = 0;
      }
    }
  }
send:
  write(fd, output.c_str(), output.length());
//   input.resize(output.length(), ' ');
  set_blocking(fd, /*output.length()*/0);
//   cout << "output:" << output << "reading...";
//   cout.flush();
//   read(fd, &*input.begin(), output.length());
  input = getser(output.length());
// input = "\xff\xff\xff\x69";
//   cout << "input:" << input;
//   cout.flush();
  output = ""; 
  byte = 0;
  char bits = 0;
  string test_should_be("");
  string test_really_is("");
  char test_bits = 0;
  char test_byte_s = 0;
  char test_byte_r = 0;
  for (short int i = 0; i < cmd->rd.length(); i++) 
  {
    switch (cmd->rd[i])
    {
      case ('0'): { }
      case ('1'):
      {
	test_byte_s = (test_byte_s << 1) | (cmd->rd[i] - '0');
	test_byte_r = (test_byte_r << 1) | ((input[i / 8] & (1 << 7 - (i % 8))) ? 1 : 0);
	test_bits++;
	break;
      }
      case ('d'):
      {
	byte = (byte << 1) | ((input[i / 8] & (1 << 7 - (i % 8))) ? 1 : 0);
	bits++;
	break;
      }
      case ('p'):
      {
	(input = "").resize(data, 0); // data in this case means the page size
	write(fd, input.c_str(), data);
	output += getser(data);
      }
    }
//     cout << "rd[" << i << "]=" << cmd->rd[i] << "s=" << test_byte_s << "r=" << test_byte_r << "test_bits=" << test_bits << "*******";
    if (bits == 8)
    {
      output += byte;
      byte = bits = 0;
    }
    if (test_bits == 8)
    {
      test_should_be += test_byte_s;
      test_really_is += test_byte_r;
      test_byte_s = test_byte_r = test_bits = 0;
    }
  }
  if (bits)
    output += byte;
  if (test_bits)
  {
    test_should_be += test_byte_s;
    test_really_is += test_byte_r;
  }
//   cout << "should_be:" << test_should_be << "really_is:" << test_really_is;
  if (test_should_be != test_really_is)
    error("incorrect reply from MCU.");
  return output;
}

void do_init()
{
  if (sinit.valid)
    do_cmd(&sinit, 0, 0, "");
  else
    error("sinit command is not defined.");
}

void do_erase()
{
  if (serase.valid)
    do_cmd(&serase, 0, 0, "");
  else
    error("serase command is not defined.");
}

void do_read(const char* fn)
{
  string output("");
  if (sreadp.valid)
    for (short int pos = 0; pos < mem; pos += pgmax) // simplified yet
      output += do_cmd(&sreadp, pos / pgaddr, pgmax, "");
  else if (sread.valid)
    for (short int pos = 0; pos < mem; pos++)
      output += do_cmd(&sread, pos, 0, "");
  else
    error("neither sread nor sreadp command is defined.");
  ofstream ofs(fn, ios::binary);
  ofs << output;
  ofs.close();
}

void do_write(const char* fn)
{
  ifstream ifs(fn, ios::binary);
  ifs.seekg(0, ifs.end);
  int fs = ifs.tellg();
  ifs.seekg(0, ifs.beg);
  string input("");
  input.resize(fs, ' ');
  ifs.read(&*input.begin(), fs);
  ifs.close();
  if (fs > mem)
    error("out of MCU memory - nothing has been written.");
  // there should be some optimization to write only modified bytes where it is suitable
  if (swritep.valid)
    for (short int pos = 0; pos < fs; pos += pgmax) // simplified yet
    {
      if ((pos + pgmin) > fs)
	input.resize((fs / pgmin + 1) * pgmin, 0xFF);
      do_cmd(&swritep, pos / pgaddr, 0, input.substr(pos, ((pos + pgmax) < fs) ? pgmax : input.length() - pos));
    }
  else if (swrite.valid)
    for (short int pos = 0; pos < fs; pos++)
      do_cmd(&swrite, pos, input[pos], "");
  else
    error("neither swrite nor swritep command is defined - nothing has been written.");
}

int main(int argc, char *argv[])
{
  mem = pgmin = pgmax = pgstep = pgaddr = 0;
  mcu_type = argv[1];
  cout << "mcu type = " << mcu_type << endl;
  ifstream cmds("uploader.conf", ios::in|ios::binary);
  if (!cmds)
    error("unable to open conf file.");
  while (!cmds.eof())
  {
    string token;
    cmds >> token;
    if (token == '[' + mcu_type + ']')
    {
      CMD *readto = &fail;
      int *Int = &mem;
      enum {WR, RD, INT} type = WR;
      while (!cmds.eof())
      {
        cmds >> token;
	if (token[0] == '[')
	  goto cmd_close;
	if      (token == "sinit"  ) {readto = &sinit;   type = WR; readto->valid = true;}
	else if (token == "serase" ) {readto = &serase;  type = WR; readto->valid = true;}
	else if (token == "sread"  ) {readto = &sread;   type = WR; readto->valid = true;}
	else if (token == "swrite" ) {readto = &swrite;  type = WR; readto->valid = true;}
	else if (token == "sreadp" ) {readto = &sreadp;  type = WR; readto->valid = true;}
	else if (token == "swritep") {readto = &swritep; type = WR; readto->valid = true;}
	else if (token == "srlock" ) {readto = &srlock;  type = WR; readto->valid = true;}
	else if (token == "swlock" ) {readto = &swlock;  type = WR; readto->valid = true;}
	else if (token == "srsig"  ) {readto = &srsig;   type = WR; readto->valid = true;}
	else if (token == "r")       {                   type = RD;}
	else if (token == "mem"    ) {Int = &mem;    type = INT;}
	else if (token == "pgmin"  ) {Int = &pgmin;  type = INT;}
	else if (token == "pgmax"  ) {Int = &pgmax;  type = INT;}
	else if (token == "pgstep" ) {Int = &pgstep; type = INT;}
	else if (token == "pgaddr" ) {Int = &pgaddr; type = INT;}
	else
	{
	  switch (type)
	  {
	    case (WR): {readto->wr = readto->wr + token; break;}
	    case (RD): {readto->rd = readto->rd + token; break;}
	    case (INT): {*Int = str2int(token); break;}
	  }
	}
      }
    }
  }
cmd_close:
  cmds.close();
  
/////////////////////////////////////////////////
// code from wallyk at stackoverflow.com begin //
fd = open (argv[2], O_RDWR | O_NOCTTY | O_SYNC);

if (fd < 0)
{
        printf ("error %d opening %s: %s\n", errno, argv[2], strerror (errno));
        return 1;
}

set_interface_attribs (fd, B1200, 0);  // set speed to 1,200 bps, 8n1 (no parity)
// set_blocking (fd, 0);                // set no blocking
// code from wallyk at stackoverflow.com end   //
/////////////////////////////////////////////////

  do_init();
  for (short int i = 3; i <= argc - 1; i++)
    if      (string(argv[i]) == "erase") do_erase();
    else if (string(argv[i]) == "read")  do_read(argv[++i]);
    else if (string(argv[i]) == "write") do_write(argv[++i]);
    else {cerr << "unknown command " << argv[i] << endl;}
 
 close(fd);
}